import java.awt.Event;
import java.awt.Component;

public class GoodFram extends java.awt.Frame {
  public GoodFram() {
    super();
  }

  public GoodFram(String title) {
    super(title);
  }

  public boolean handleEvent( Event evt) {
    if (evt.id == Event.WINDOW_ICONIFY) {
      hide();
      return false;
    }
    
    if (evt.id == Event.WINDOW_DESTROY) {
      Component c[] = getComponents();
      for (int i = 0; i < c.length; i++) 
	c[i].handleEvent(evt);
      dispose();
      return false;
    }

    return super.handleEvent(evt);
  } // handleEvent

} // end class goodFrame
