import java.awt.Graphics;
import java.awt.GridLayout;
import Threader;
import GoodFram;

public class GreatRac extends java.applet.Applet implements Runnable {

Threader theRacers[];
static int racerCount = 3;
Thread theThreads[];
Thread thisThread;
static boolean inApplet=true;
int numberofThreadsAtStart;

  public void init() {
    numberofThreadsAtStart = Thread.activeCount();
    setLayout(new GridLayout(racerCount,1));
    theRacers= new Threader[racerCount];
    theThreads = new Thread[racerCount];
    for (int x=0; x < racerCount; x++) {
      theRacers[x] = new Threader("Racer #"+x);
      theRacers[x].resize(size().width,size().height/racerCount);
      add (theRacers[x]);
      theThreads[x] = new Thread(theRacers[x]);
    } // for
  } 

  public void start() {
    for (int x = 0; x < racerCount; x++) {
      theThreads[x].start();
    }
    thisThread = new Thread(this);
    thisThread.start();
  }

  public void stop() {
    thisThread.stop();
  }

  public void run() {
    while (Thread.activeCount() > numberofThreadsAtStart + 2) {
      try {
	thisThread.sleep(100);
      } 
      catch (InterruptedException e) {
	System.out.println("thisThread was interrupted");
      }
    }
    if (inApplet) {
      stop();
      destroy();
    } else {
      System.exit(0);
    }
  }
  

  public static void main (String argv[]) {
    inApplet = false;
    if (argv.length > 0)
      racerCount = Integer.parseInt(argv[0]);
    
    GoodFram theFrame = new GoodFram("The Great Thread Race");
    GreatRac theRace = new GreatRac();
    theFrame.resize(400,200);
    theFrame.add("Center", theRace);
    theFrame.show();
    theRace.init();
    theFrame.pack();
    theRace.start();
  }
} // end class GreatRace

