import java.awt.Graphics;
import java.awt.Color;

public class Threader extends java.awt.Canvas implements Runnable {
  int myPosition = 0;
  int numberofSteps = 600;
  String myName;

  public Threader (String inName) {
    myName = new String(inName);
  }

  public synchronized void paint (Graphics g) {
    g.setColor(Color.black);
    g.drawLine (0,size().height/2, size().width, size().height/2);
    
    g.setColor(Color.yellow);
    g.fillOval((myPosition*size().width/numberofSteps), 0, 15, 
	       size().height);
  }

  public void run() {
    while ( myPosition < numberofSteps) {
      myPosition++;
      repaint();
      try {
	Thread.currentThread().sleep(10);
      } 
      catch (Exception e) {
	System.out.println("Exception on sleep");
      }
    } // while
  } // run

} // end class Threader
